// LayoutManager.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//

#ifndef _LAYOUT_MANAGER_H_
#define _LAYOUT_MANAGER_H_

#include <Rect.h>

#include "MeterMessages.h"
#include "BaseView.h"

#define	LT_VERTICAL		BY_LY_VER
#define	LT_HORIZONTAL	BY_LY_HOR

typedef uint32 LayoutType;

class LayoutManager {
  public:
	virtual ~LayoutManager() {};
	virtual void SetLimits();
	virtual void Layout();
	inline LayoutType GetLayoutType() const { return type; };
	
	static LayoutManager *CreateLayoutManager(LayoutType layoutType,
											  BaseView *baseView);
	
  protected:
	LayoutManager(LayoutType layoutType, BaseView *base)
	 : view(base), type(layoutType) {};
	
	virtual void doSetLimits(const BRect &min, const BRect &max) = 0;
	virtual void doLayout() = 0;

	inline BaseView *GetBaseView() { return view; };
	inline BRect &GetMin() { return min; };
	inline BRect &GetMax() { return max; };

  private:
	BaseView *view;
	BRect min, max;
	const LayoutType type;
};

#endif /* _LAYOUT_MANAGER_H_ */
