// LabelStringView.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#ifndef _LABEL_STRING_VIEW_H_
#define _LABEL_STRING_VIEW_H_

#include <View.h>
#include <Rect.h>
#include <Message.h>
#include <StringView.h>

#include "BaseView.h"

// class LabelStringView
class _EXPORT LabelStringView : public BView {
public:
	LabelStringView(BRect frame, const char *label,
					const char* value, const char *unit);
	LabelStringView(BMessage *archive);
	virtual ~LabelStringView();
	
	void Update(const char *value);
	
	// Override BView methods
	void AttachedToWindow();
	void FrameResized(float width, float height);
	
	// Archivable
	status_t Archive(BMessage *archive, bool deep) const;
	static BArchivable *Instantiate(BMessage *archive);

private:
	// To avoid misuse
	LabelStringView(const LabelStringView &);
	LabelStringView &operator=(const LabelStringView &) { return *this; };
	
	// Adjust itself
	void Adjust();
	
	BStringView *_labelView;
	BStringView *_valueView;
	BStringView *_unitView;
};

#endif /* _LABLE_STRING_VIEW_H_ */
