// LineGraphView.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#ifndef _LINE_GRAPH_VIEW_H_
#define _LINE_GRAPH_VIEW_H_

#include <View.h>
#include <Rect.h>
#include <Message.h>

#include "ActualLineGraphView.h"

// This is a generic line graph view.
//
class _EXPORT LineGraphView : public BView {
public:
	LineGraphView(BRect frame, const char *name, float maximum = 0.0f);
	LineGraphView(BMessage *archive);
	~LineGraphView();
	
	// Updates the line graph.
	void Update(float rate);

	// BView method override
	void AttachedToWindow();
	void FrameResized(float width, float height);
	void Draw(BRect updateRect);
	
	// Archivable
	status_t Archive(BMessage *archive, bool deep) const;
	static BArchivable *Instantiate(BMessage *archive);
	
private:
	LineGraphView(const LineGraphView &);
	LineGraphView &operator=(const LineGraphView &) { return *this; };
	
	void RedrawAllLines(float width, float height);
	void Adjust(float width, float height);
	
	static bool Regurate(void *item, void *rate);
	
	ActualLineGraphView *view;
};

#endif /* _LINE_GRAPH_VIEW_H_ */
