// Profile.h
// Copyright(C) 1999 by Kiyoshi Kobayashi. All rights reserved.
//
//
#ifndef _PROFILE_H_
#define _PROFILE_H_

#include <Rect.h>

#include "LayoutManager.h"

// This class encapsulates the profile storage of the BeYap.
//
class Profile {
public:
	Profile(const char *file);
	virtual ~Profile();
	
	status_t InitCheck();
	status_t Commit();
	
	inline const BRect &GetFrame() const { return frame; };
	inline void SetFrame(const BRect &newFrame) { frame = newFrame; };

	inline LayoutType GetLayoutType() const { return layout; };
	inline void SetLayoutType(LayoutType newType) { layout = newType; };
	
	inline bool GetAllWorkspaces() const { return all; };
	inline void SetAllWorkspaces(bool newValue) { all = newValue; };
	
	inline bigtime_t GetInterval() const { return interval; };
	inline void SetInterval(bigtime_t newValue) { interval = newValue; };

private:
	status_t CreateDefaultProfile(BDirectory *dir);
	status_t ReadProfile(BNode *file);
	status_t WriteProfile(BNode *file);
	
	const char *filename;
	status_t stat;
	BRect frame;
	LayoutType layout;
	bool all;
	bigtime_t interval;
};

#endif // _PROFILE_H_
